<?php

/* $Id: common.inc.php,v 1.1.1.1.2.23 2001/11/28 17:04:13 justin Exp $ */

/* program info */
$program = 'Ticketsmith';
$version = '1.0RC1';
$website = 'http://www.voxel.net/projects/ticketsmith/';
$xmailer = $program . ' v' . $version . ' (' . $website . ')';

/* error handler */
function fatal_error ($reason) {

    die($reason);

}

/* database connection */
if (!($db_link = @mysql_pconnect($CONFIG['db_hostname'], $CONFIG['db_username'], $CONFIG['db_password']))) {
    fatal_error('A database connection error has occurred!');
}
@mysql_select_db($CONFIG['db_database'], $db_link) || fatal_error('A database selection error has occurred!');

/* do a MySQL query */
function do_query ($query, $db_link) {

	$result = @mysql_query($query, $db_link);
	if (!$result) {
		fatal_error("A database query error has occurred!");
	}
    else {
		return($result);
	}
	
}

/* get single result value */
function query2result ($query, $db_link) {

	$result = do_query($query, $db_link);
	$row = @mysql_result($result, 0);
	return($row);

}

/* get result in numeric array */
function query2array ($query, $db_link) {

	$result = do_query($query, $db_link);
	$row = @mysql_fetch_row($result);
	return($row);

}

/* get result in associative array */
function query2hash ($query, $db_link) {

	$result = do_query($query, $db_link);
	$row = @mysql_fetch_array($result);
	return($row);
	
}

/* get row of result */
function result2row ($result) {

    $row = @mysql_fetch_row($result);
    return($row);

}

/* get row of result in hash */
function result2hash ($result) {

    $row = @mysql_fetch_array($result);
    return($row);

}

/* find number of rows in query result */
function number_rows ($result) {

    $number_rows = @mysql_num_rows($result);
    return($number_rows);

}

/* put rows from a column into an array */
function column2array ($query, $db_link) {

    $result = do_query($query, $db_link);
    while ($row = @mysql_fetch_array($result)) {
        $array[] = $row[0];
    }
    return($array);

}

/* common page header */
function common_header ($title) {

    global $CONFIG;

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" 
    "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>

<head>
<title><?php print($GLOBALS["program"] . " v" . $GLOBALS["version"]) ?> - <?php print($title) ?></title>
<link rel="stylesheet" href="<?php print($CONFIG["relative_path"] . "/style.css") ?>" type="text/css">
</head>

<body bgcolor="<?php print($GLOBALS["CONFIG"]["background_color"]) ?>">
<center>
<form name="form" action="<?php print($GLOBALS["PHP_SELF"]) ?>" method="POST">
<?php

}

/* common page footer */
function common_footer () {

?>
</form>
<div class="footer"><?php print("Powered by " . $GLOBALS["program"] . " v" . $GLOBALS["version"]) ?></div>
</center>
</body>

</html>
<?php

}

/* create drop-down box */
function create_selectbox ($name, $options, $selected) {

    $output .= "<select name=\"$name\" onChange=\"document.form.submit()\">\n";
	while(list($key, $val) = each($options)) {
		$output .= "<option value=\"$key\"";
		if ($key == $selected) {
			$output .= " selected";
		}
		$output .= ">$val\n";
		$loop++;
	}
	$output .= "</select>\n";
    
    return($output);

}

/* escape special characters */
function escape_string ($string) {
    
    if (!get_magic_quotes_gpc()) {
        $string = addslashes($string);
    }
    
    return($string);

}

/* format "time ago" date string */
function get_time_ago ($timestamp) {

    $elapsed_seconds = time() - $timestamp;
    
    if ($elapsed_seconds < 60) { // seconds ago
        if ($elapsed_seconds) {
            $interval = $elapsed_seconds;
        }
        else {
            $interval = 1;
        }
        $output = "$interval second";
    }
    elseif ($elapsed_seconds < (60 * 60)) { // less than an hour (minutes ago)
        $interval = round($elapsed_seconds / 60);
        $output = "$interval minute";
    }
    elseif ($elapsed_seconds < (60 * 60 * 24)) { // less than a day (hours ago)
        $interval = round($elapsed_seconds / (60 * 60));
        $output = "$interval hour";
    }
    elseif ($elapsed_seconds < (60 * 60 * 24 * 7)) { // less than a week (days ago)
        $interval = round($elapsed_seconds / (60 * 60 * 24));
        $output = "$interval day";
    }
    elseif ($elapsed_seconds < (60 * 60 * 24 * 7 * 4)) { // less than a month (weeks ago)
        $interval = round($elapsed_seconds / (60 * 60 * 24 * 7));
        $output = "$interval week";
    }
    elseif ($elapsed_seconds < (60 * 60 * 24 * 7 * 4 * 12)) { // less than a year (months ago)
        $interval = round($elapsed_seconds / (60 * 60 * 24 * 7 * 4));
        $output = "$interval month";
    }
    else { // years ago
        $interval = round($elapsed_seconds / (60 * 60 * 24 * 7 * 4 * 12));
        $output = "$interval year";
    }
    
    if ($interval > 1) {
        $output .= "s";
    }
    
    $output .= " ago";
    
    return($output);
        
}

/* smart word wrapping */
function smart_wrap ($text, $width) {

    if (function_exists("wordwrap")) {
        if (preg_match("/[^\\n]{100,}/", $text)) {
            $text = wordwrap($text, $width);
        }
    }
    else {
        $text = "Wordwrap unsupported in PHP " . phpversion() . "\n\n";;
        $text .= "Please adjust your Ticketsmith configuration and/or upgrade PHP\n";
    }

    return($text);

}

/* format display field */
function format_field ($value, $type, $ticket = NULL) {

    global $CONFIG;
    
    switch ($type) {
        case "user":
            if ($value) {
                $output = query2result("SELECT name FROM users WHERE id = '$value'", $GLOBALS["db_link"]);
            } else {
                $output = "-";
            }
            break;
        case "status":
            $output = create_selectbox("type_toggle", array("Open" => "Open", "Closed" => "Closed", "Deleted" => "Deleted"), $value);
            break;
        case "priority_view":
            $priority = $CONFIG["priority_names"][$value];
            $color = $CONFIG["priority_colors"][$value];
            if ($value == 3) {
                $priority = "<b>$priority</b>";
            }
            if ($value == 4) {
                $priority = "<blink><b>$priority</b></blink>";
            }
            $output = "<font color=\"$color\">$priority</font>";
            break;
        case "priority_select":
            $output = create_selectbox("priority_toggle", $CONFIG["priority_names"], $value);
            break;
        case "assignment":
            $options[0] = "-";
            $query = "SELECT id, name FROM users WHERE username != 'admin' ORDER BY name";
            $result = do_query($query, $GLOBALS["db_link"]);
            while ($row = result2hash($result)) {
                $options[$row["id"]] = $row["name"];
            }
            $output = create_selectbox("assignment_toggle", $options, $value);
            break;
        case "view":
            if ($CONFIG["index_link"] == "latest") {
                $latest_value = query2result("SELECT ticket FROM tickets WHERE parent = '$value' ORDER BY ticket DESC LIMIT 1", $GLOBALS["db_link"]);
                if ($latest_value) {
                    $value = $latest_value;
                }
            }
            $output = "<a href=\"" . $CONFIG["relative_path"] . "/view.php?ticket=$value\">";
            $output .= "<img src=\"" . $CONFIG["relative_path"] . "/posticon.gif\" border=\"0\" alt=\"[*]\"></a>";
            break;
        case "open_date":
            $output = get_time_ago($value);
            if ($CONFIG["warning_active"]) {
                if (time() - $value > $CONFIG["warning_age"] * 3600) {
                    $output = "<font color=\"" . $CONFIG["warning_color"] . "\">" . $output . "</font>";
                }
            }
            break;
        case "activity_date":
            if (!$value) {
                $output = "<i>none</i>";
            }
            else {
                $output = get_time_ago($value);
            }
            $latest_followup_type = query2result("SELECT type FROM tickets WHERE parent = '$ticket' ORDER BY timestamp DESC LIMIT 1", $GLOBALS["db_link"]);
            if ($latest_followup_type) {
                $latest_followup_type = preg_replace("/(\w+)\s.*/", "\\1", $latest_followup_type);
                $output .= " [$latest_followup_type]";
            }
            break;
        case "elapsed_date":
            $output = date($CONFIG["date_format"], $value);
            $time_ago = get_time_ago($value);
            $output .= " <i>($time_ago)</i>";
            break;
        case "body":
            $value = htmlspecialchars($value);
            $value = quoted_printable_decode($value);
            $output = "<table width=\"100%\" border=\"1\" cellspacing=\"0\" cellpadding=\"10\">\n";
            $output .= "<tr><td bgcolor=\"" . $CONFIG["ticket_color"] . "\">\n<tt><pre>\n";
            $url_find = "/(http|https|ftp|news|telnet|finger)(:\/\/[^ \">\\t\\r\\n]*)/";
            $url_replace = "<a href=\"\\1\\2\" target=\"new\">";
            $url_replace .= "<span style=\"font-size: 10pt;\">\\1\\2</span></a>";
            $value = preg_replace($url_find, $url_replace, $value);
            if ($CONFIG["wordwrap"]) {
                $output .= smart_wrap($value, 72);
            }
            else {
                $output .= $value;
            }
            $output .= "\n</pre></tt>\n</td></tr>\n</table>\n";
            break;
        case "followup":
            $output = "\n<tt>\n";
            $output .= "<textarea name=\"followup\" wrap=\"hard\" cols=\"72\" rows=\"20\">\n";
            $signature = query2result("SELECT signature FROM users WHERE id = '" . $GLOBALS["login_id"] . "'", $GLOBALS["db_link"]);
            if ($signature) {
                $output .= "\n";
                $output .= "-- \n";
                $output .= $signature;
            }
            $output .= "\n\n";
            $output .= "---- Original message ----\n\n";
            if ($CONFIG["wordwrap"]) {
                $value = smart_wrap($value, 70);
            }
            $value = htmlspecialchars($value);
            $value = quoted_printable_decode($value);
            $lines = explode("\n", $value);
            for ($loop = 0; $loop < count($lines); $loop++) {
                $lines[$loop] = "&gt; " . $lines[$loop];
            }
            $output .= join("\n", $lines);
            $output .= "\n</textarea>\n";
            $output .= "</tt>\n";
            break;
        case "subject":
            $value = preg_replace("/\s*Re:\s*/i", "", $value);
            $value = preg_replace("/(\[\#\d+\])(\w+)/", "\\2", $value);
            $value = "Re: " . $value;
            $value = htmlspecialchars($value);
            $output .= "<input type=\"text\" name=\"subject\" value=\"$value\" size=\"70\">\n";
            break;
        case "cc":
            $value = htmlspecialchars($value);
            $output = "<input type=\"text\" name=\"cc\" value=\"$value\" size=\"70\">";
            break;
        case "recipient":
            $value = htmlspecialchars($value);
            $output = "<input type=\"text\" name=\"recipient\" value=\"$value\" size=\"70\">";
            break;
        case "original_author":
            if ($value) {
                $value = ereg_replace("\"", "", $value);
                $output = htmlspecialchars($value);
            }
            else {
                $output = "<i>(original ticket author)</i>";
            }
            break;
        case "email":
            if ($value) {
                $value = ereg_replace("\"", "", $value);
                $output = htmlspecialchars($value);
            }
            else {
                $output = "<i>none</i>";
            }
            break;
        default:
            $output = $value ? htmlspecialchars($value) : "<i>none</i>";
    }
    
    return($output);

}

/* register login stuff */
session_register('login_id');
session_register('login_name');

/* figure out parent & type */
if ($ticket) {
    list($ticket_type, $ticket_parent) = query2array("SELECT type, parent FROM tickets WHERE ticket = '$ticket'", $db_link);
}

/* login functionality */
if ($login_attempt && $password_attempt) {

    list($select_id, $select_username, $select_password) = query2array("SELECT id, username, password FROM users WHERE username = '$login_attempt'", $db_link);
    
    if ($password_attempt == $select_password) {
        $login_id = $select_id;
        $login_name = $select_username;
        if ($login_name == 'admin') {
            header('Location: ' . $CONFIG['relative_path'] . '/admin.php');
        }
        else {
            header('Location: ' . $CONFIG['relative_path'] . '/index.php');
        }
        exit();
    }

}

/* logout functionality */
if ($logout == '1') {

    session_destroy();
    header('Location: ' . $CONFIG['relative_path'] . '/login.php');
    exit();

}

/* check login status */
if ($login_name == 'admin' && ($PHP_SELF != $CONFIG['relative_path'] . '/admin.php')) {

    header('Location: ' . $CONFIG['relative_path'] . '/admin.php');
    exit();

}
elseif (!isset($login_name) && $PHP_SELF != $CONFIG['relative_path'] . '/login.php') {

    header('Location: ' . $CONFIG['relative_path'] . '/login.php');
    exit();

}

?>
