<?php

/* $Id: search.php,v 1.1.1.1.2.5 2001/08/13 19:37:14 justin Exp $ */

require("config.inc.php");
require("common.inc.php");

/* set title */
$title = "Search Tickets";

/* start page */
common_header($title);

/* start table */
print("<table width=\"75%\" border=\"1\" cellspacing=\"5\" cellpadding=\"5\">\n");
print("<tr>\n");
print("<td colspan=\"2\" align=\"center\" bgcolor=\"" . $CONFIG["heading_color"] . "\">\n");
print("<div class=\"heading\">$title</div>\n");
print("</td>\n</tr>\n");

/* field select */
print("<tr>\n");
print("<td align=\"right\"><b>Field</b></td>\n");
print("<td>");
$field_choices = array("author"  => "Author", 
                       "body"    => "Body", 
                       "subject" => "Subject");


$field_selectbox = create_selectbox("search_field", $field_choices, $search_field);
print("$field_selectbox\n");
print("</td>\n");
print("</tr>\n");

/* pattern select */
print("<tr>\n");
print("<td align=\"right\"><b>Pattern</b></td>\n");
print("<td><input type=\"text\" name=\"search_pattern\" value=\"$search_pattern\"></td>\n");
print("</tr>\n");

/* depth select */
print("<tr>\n");
print("<td align=\"right\"><b>Depth</b></td>\n");
print("<td>");
$depth_choices = array("All"     => "All Tickets", 
                       "Open"    => "Open Parents", 
                       "Closed"  => "Closed Parents",
                       "Deleted" => "Deleted Parents",
                       "Child"   => "Followups &amp; Comments");

$depth_selectbox = create_selectbox("search_depth", $depth_choices, $search_depth);
print("$depth_selectbox\n");
print("</td>\n");
print("</tr>\n");

/* sort select */
print("<tr>\n");
print("<td align=\"right\"><b>Sort By</b></td>\n");
print("<td>");
$sort_choices = array("ticket"     => "Ticket",
                      "author"     => "Author",
                      "subject"    => "Subject",
                      "timestamp"  => "Date",
                      "activity"   => "Activity",
                      "type"       => "Type",
                      "priority"   => "Priority",
                      "assignment" => "Owner");

$sort_selectbox = create_selectbox("sort_column", $sort_choices, $sort_column);
print($sort_selectbox);
print(" <input type=\"radio\" name=\"sort_direction\" value=\"ASC\"> Ascending");
print(" <input type=\"radio\" name=\"sort_direction\" value=\"DESC\" checked> Descending");
print("</td>\n");
print("</tr>\n");

/* submit button */
print("<tr>\n");
print("<td><br></td>\n");
print("<td><input type=\"submit\" value=\"Search\"></td>\n");
print("</tr>\n");

/* output footer */
print("<tr>\n");
print("<td><br></td>\n");
print("<td><a href=\"" . $CONFIG["relative_path"] . "/index.php\">Return to ticket list</a></td>\n");
print("</tr>\n");

/* end table */
print("</table>\n");

if ($search_pattern) {

    /* set fields */
    $fields = array("columns"  => array("ticket", "author", "subject", "timestamp", "type"),
                    "types"    => array("view", "email", "normal", "elapsed_date", "normal"),
                    "aligns"   => array("center", "left", "left", "left", "center"));
    
    /* start results table */
    print("<p>\n");
    print("<table width=\"75%\" border=\"1\" cellspacing=\"5\" cellpadding=\"5\">\n");

    /* form search query */
    $select_columns = join(", ", $fields["columns"]);
    $search_pattern = "%" . escape_string($search_pattern) . "%";
    $query = "SELECT $select_columns FROM tickets WHERE $search_field LIKE '$search_pattern'";
    if ($search_depth == "Child") {
        $query .= " AND parent != 0";
    }
    elseif ($search_depth != "All") {
        $query .= " AND type = '$search_depth'";
    }
    $query .= " ORDER BY $sort_column $sort_direction";
    
    /* perform search */
    $result = do_query($query, $db_link);
    
    /* display results */
    $result_count = number_rows($result);
    if ($result_count) {
        print("<tr><td colspan=\"5\">There were $result_count results in the given search.</td></tr>\n");
        while ($row = result2hash($result)) {
            print("<tr>");
            for ($loop = 0; $loop < count($fields["columns"]); $loop++) {
                print("<td align=\"" . $fields["aligns"][$loop] . "\">");
                print(format_field($row[$fields["columns"][$loop]], $fields["types"][$loop]));
                print("</td>");
            }
            print("</tr>\n");
        }
    }
    else {
        print("<tr><td>There were no results in the given search.</td></tr>\n");
    }
    
    /* end results table */
    print("</table>\n");

}

/* end page */
common_footer();

?>
