<?php

/* $Id: view.php,v 1.1.1.1.2.7 2001/08/13 19:37:15 justin Exp $ */

require("config.inc.php");
require("common.inc.php");

/* initialize fields */
if ($ticket_type == "Staff Followup" || $ticket_type == "Client Followup") {
    
    $title = "$ticket_type to Ticket #$ticket_parent";
    
    $fields = array("headings" => array("From", "To", "Subject", "Date", "Cc", "<br>"),
                    "columns"  => array("author", "recipient", "subject", "timestamp", "cc", "body"), 
                    "types"    => array("email", "original_author", "normal", "elapsed_date", "email", "body"));

}
elseif ($ticket_type == "Staff Comment") {

    $title = "$ticket_type to Ticket #$ticket_parent";
    
    $fields = array("headings" => array("From", "Date", "<br>"),
                    "columns"  => array("author", "timestamp", "body"), 
                    "types"    => array("email", "elapsed_date", "body"));

}
else {
    
    $title = "Ticket #$ticket";
    
    $fields = array("headings" => array("From", "Subject", "Date", "Cc", "Status", 
                                        "Priority", "Owner", "<br>"),
                    
                    "columns"  => array("author", "subject", "timestamp", "cc", 
                                        "type", "priority", "assignment", "body"),
                    
                    "types"    => array("email", "normal", "elapsed_date", "email", 
                                        "status", "priority_select", "assignment", "body"));
}

/* perform updates */
if ($type_toggle || $priority_toggle || $assignment_toggle) {
    do_query("UPDATE tickets SET type = '$type_toggle', priority = '$priority_toggle', assignment = '$assignment_toggle' WHERE ticket = '$ticket'", $db_link);
}

/* start page */
common_header($title);

/* start form */
print("<input type=\"hidden\" name=\"ticket\" value=\"$ticket\">\n");

/* start table */
print("<table width=\"75%\" border=\"1\" cellspacing=\"5\" cellpadding=\"5\">\n");
print("<tr>\n");
print("<td colspan=\"2\" align=\"center\" bgcolor=\"" . $CONFIG["heading_color"] . "\">\n");
print("<div class=\"heading\">$title</div>\n");
print("</td>\n");
print("</tr>\n");

/* get ticket */
$ticket_info = query2hash("SELECT * FROM tickets WHERE ticket = $ticket", $db_link);

/* output ticket */
for ($loop = 0; $loop < count($fields["headings"]); $loop++) {
    print("<tr>\n");
    print("<td align=\"left\"><b>" . $fields["headings"][$loop] . "</b></td>");
    print("<td align=\"left\">" . format_field($ticket_info[$fields["columns"][$loop]], $fields["types"][$loop]) . "</td>\n");
    print("</tr>\n");
}

/* output attachment indicator */
if (query2result("SELECT attachment FROM tickets WHERE ticket = '$ticket'", $db_link)) {
    print("<tr>\n");
    print("<td align=\"left\"><b>Attachments</b></td>");
    print("<td align=\"left\">This email had attachments which were removed.</td>\n");
    print("</tr>\n");
}

/* output followup navigation */
if ($ticket_type != "Staff Followup" && $ticket_type != "Client Followup" && $ticket_type != "Staff Comment") {

    /* output followups */
    print("<tr>\n");
    print("<td align=\"left\" valign=\"top\"><b>Followups</b></td>\n");
    print("<td align=\"left\" valign=\"top\">\n");
   
    /* grab followups */
    $query = "SELECT ticket, type, timestamp, author FROM tickets WHERE parent = '$ticket' ORDER BY ticket " . $CONFIG["followup_order"];
    $result = do_query($query, $db_link);
    
    if (number_rows($result)) {

        /* print followups */
        print("<table width=\"100%\" border=\"1\" cellspacing=\"5\" cellpadding=\"5\">\n");
        while ($row = result2hash($result)) {
            
            /* determine row color */
            $color = ($number++ % 2 == 0) ? "#d3dce3" : "#dddddd";

            /* start row */
            print("<tr>\n");
            
            /* do number/author */
            print("<td bgcolor=\"$color\">\n");
            print("<b>$number</b> : \n");
            $row["author"] = ereg_replace("\"", "", $row["author"]);
            $row["author"] = htmlspecialchars($row["author"]);
            print($row["author"] . "\n");    
            print("</td>\n");
            
            /* do type */
            print("<td bgcolor=\"$color\"><a href=\"$PHP_SELF?ticket=" . $row["ticket"] . "\">" . $row["type"] . "</a></td>\n");
            
            /* do timestamp */
            print("<td bgcolor=\"$color\">\n");
            print(get_time_ago($row["timestamp"]));
            print("</td>\n");

            /* end row */
            print("</tr>\n");
        
        }
        print("</table>\n");
    
    }
    else {
        print("<i>none</i>\n");
    }
    
    print("</td>\n</tr>\n");
    
}

else {

    /* get peer followups */
    $results = do_query("SELECT ticket, type FROM tickets WHERE parent = '$ticket_parent' ORDER BY ticket " . $CONFIG["followup_order"], $db_link);

    /* parse followups */
    while ($row = result2hash($results)) {
        $peer_tickets[] = $row["ticket"];
    }
    
    /* count peers */
    $peer_count = count($peer_tickets);
    
    if ($peer_count > 1) {
    
        /* start row */
        print("<tr>\n");
        print("<td><b>Followups</b></td>\n");
    
        /* start cell */
        print("<td valign=\"middle\">");
        
        /* form peer links */
        for ($loop = 0; $loop < $peer_count; $loop++) {
            if ($peer_tickets[$loop] == $ticket) {
                $viewed_peer = $loop;
                $peer_strings[$loop] = "<b>" . ($loop + 1) . "</b>";
            }
            else {
                $peer_strings[$loop] = "<a href=\"$PHP_SELF?ticket=$peer_tickets[$loop]\">" . ($loop + 1) . "</a>";
            }
        }
            
        /* previous navigator */
        if ($viewed_peer > 0) {
            print("<a href=\"$PHP_SELF?ticket=" . $peer_tickets[$viewed_peer - 1] . "\">");
            print($CONFIG["followup_order"] == "ASC" ?  "older" : "newer");
            print("</a> | ");
        }
        
        /* ticket list */
        print(join(" | ", $peer_strings));
        
        /* next navigator */
        if ($peer_count - $viewed_peer > 1) {
            print(" | <a href=\"$PHP_SELF?ticket=" . $peer_tickets[$viewed_peer + 1] . "\">");
            print($CONFIG["followup_order"] == "ASC" ?  "newer" : "older");
            print("</a>");
        }

        /* end cell */
        print("</td>\n");

        /* end row */
        print("</tr>\n");
    
    }

}

/* output action links */
print("<tr>\n");
print("<td><br></td>\n");
print("<td>\n");
print("<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n");
if ($ticket_type == "Staff Followup" || $ticket_type == "Client Followup" || $ticket_type == "Staff Comment") {
    print("<tr><td align=\"left\"><a href=\"" . $CONFIG["relative_path"] . "/followup.php?ticket=$ticket\">Post followup</a> | ");
    print("<a href=\"" . $CONFIG["relative_path"] . "/comment.php?ticket=$ticket\">Post comment</a> | ");
    print("<a href=\"" . $CONFIG["relative_path"] . "/view.php?ticket=$ticket_parent\">Return to parent</a> | ");
}
else {
    print("<tr><td align=\"left\"><a href=\"" . $CONFIG["relative_path"] . "/followup.php?ticket=$ticket\">Post followup</a> | ");
    print("<a href=\"" . $CONFIG["relative_path"] . "/comment.php?ticket=$ticket\">Post comment</a> | ");
}
print("<a href=\"" . $CONFIG["relative_path"] . "/index.php\">Return to ticket list</a></td>");
print("<td align=\"right\"><a href=\"$PHP_SELF?ticket=$ticket\">Back to top</a></td></tr>\n");
print("</table>\n");
print("</td>");
print("</tr>\n");

/* end table */
print("</table>\n");

/* end page */
common_footer();

?>
